searchNodes=[{"ref":"AnalyzerModule.html","title":"AnalyzerModule","type":"module","doc":"Analyzer takes in a repo url and coordinates the analysis, returning a simple JSON report."},{"ref":"AnalyzerModule.html#analyze/2","title":"AnalyzerModule.analyze/2","type":"function","doc":"analyze/2: returns the LowEndInsight report as JSON for multiple_repos Returns Map. Examples iex&gt; {:ok, report} = AnalyzerModule.analyze([&quot;https://github.com/kitplummer/xmpp4rails&quot;,&quot;https://github.com/kitplummer/lita-cron&quot;], &quot;iex&quot;) iex&gt; _count = report[:metadata][:repo_count] 2"},{"ref":"GitHelper.html","title":"GitHelper","type":"module","doc":"Collection of lower-level functions for analyzing outputs from git command."},{"ref":"GitHelper.html#get_avg_tag_commit_time_diff/1","title":"GitHelper.get_avg_tag_commit_time_diff/1","type":"function","doc":"get_avg_tag_commit_tim_diff/1: return the average time between commits within each subarray representing a tag"},{"ref":"GitHelper.html#get_contributor_counts/1","title":"GitHelper.get_contributor_counts/1","type":"function","doc":"get_contributor_counts/1: Gets the number of contributions belonging to each author and return a map of %{name =&gt; number}"},{"ref":"GitHelper.html#get_filtered_contributor_count/2","title":"GitHelper.get_filtered_contributor_count/2","type":"function","doc":"det_filtered_contributor_count/2: Gets the resolved list of contributers, return count and list"},{"ref":"GitHelper.html#get_total_tag_commit_time_diff/1","title":"GitHelper.get_total_tag_commit_time_diff/1","type":"function","doc":"get_total_tag_commit_time_diff/1: return the total time between commits within each subarray representing a tag"},{"ref":"GitHelper.html#parse_diff/1","title":"GitHelper.parse_diff/1","type":"function","doc":"parse_diff/1: returns the relevant information contained in the last array position of a diff array"},{"ref":"GitHelper.html#split_commits_by_tag/1","title":"GitHelper.split_commits_by_tag/1","type":"function","doc":"split_commits_by_tag/1: returns a list with sublists arranged by tag"},{"ref":"GitModule.html","title":"GitModule","type":"module","doc":"Collections of functions for interacting with the git command to perform queries."},{"ref":"GitModule.html#clone_repo/1","title":"GitModule.clone_repo/1","type":"function","doc":"clone/1: clones the repo"},{"ref":"GitModule.html#delete_repo/1","title":"GitModule.delete_repo/1","type":"function","doc":""},{"ref":"GitModule.html#get_commit_dates/1","title":"GitModule.get_commit_dates/1","type":"function","doc":"get_commit_dates/1: returns a list of unix timestamps representing commit times"},{"ref":"GitModule.html#get_contributor_count/1","title":"GitModule.get_contributor_count/1","type":"function","doc":"get_contributors_count/1: returns the number of contributors for a given Git repo"},{"ref":"GitModule.html#get_contributor_distribution/1","title":"GitModule.get_contributor_distribution/1","type":"function","doc":""},{"ref":"GitModule.html#get_diff_2_commits/2","title":"GitModule.get_diff_2_commits/2","type":"function","doc":"get_last_n_commits/2: returns a list of lines generated from the diff of two commits"},{"ref":"GitModule.html#get_functional_contributors/1","title":"GitModule.get_functional_contributors/1","type":"function","doc":""},{"ref":"GitModule.html#get_last_2_delta/1","title":"GitModule.get_last_2_delta/1","type":"function","doc":"get_last_2_delta/1: returns the lines changed, files changed, additions and deletions in the last commit"},{"ref":"GitModule.html#get_last_commit_date/1","title":"GitModule.get_last_commit_date/1","type":"function","doc":"get_last_commit_date/1: returns the date of the last commit"},{"ref":"GitModule.html#get_last_n_commits/2","title":"GitModule.get_last_n_commits/2","type":"function","doc":"get_last_n_commits/1: returns a list of the short hashes of the last n commits"},{"ref":"GitModule.html#get_recent_changes/1","title":"GitModule.get_recent_changes/1","type":"function","doc":"get_recent_changes/1: returns the fraction of changed lines in the last commit by the total lines in the repo"},{"ref":"GitModule.html#get_tag_and_commit_dates/1","title":"GitModule.get_tag_and_commit_dates/1","type":"function","doc":"get_tag_and_commit_dates/1: returns a list of lists of unix timestamps representing commit times with each lsit belonging to a different tag"},{"ref":"GitModule.html#get_total_lines/1","title":"GitModule.get_total_lines/1","type":"function","doc":"get_total_lines/1: returns the total lines and files contained in a repo as of the latest commit"},{"ref":"Helpers.html","title":"Helpers","type":"module","doc":"Collection of generic helper functions."},{"ref":"Helpers.html#count_forward_slashes/1","title":"Helpers.count_forward_slashes/1","type":"function","doc":""},{"ref":"Helpers.html#get_slug/1","title":"Helpers.get_slug/1","type":"function","doc":"get_slug/1: extracts the slug from the provided URI argument and returns the path Example iex(1)&gt; {:ok, slug} = Helpers.get_slug(&quot;https://github.com/kitplummer/xmpprails&quot;) {:ok, &quot;kitplummer/xmpprails&quot;} iex(2)&gt; slug &quot;kitplummer/xmpprails&quot;"},{"ref":"Helpers.html#split_slug/1","title":"Helpers.split_slug/1","type":"function","doc":"split_slug/1: splits apart the username and repo from a git slug returning discrete stings. Examples iex(6)&gt; {:ok, org, repo} = Helpers.split_slug(&quot;kitplummer/xmpprails&quot;) {:ok, &quot;kitplummer&quot;, &quot;xmpprails&quot;} iex(7)&gt; org &quot;kitplummer&quot; iex(8)&gt; repo &quot;xmpprails&quot;"},{"ref":"Mix.Tasks.Analyze.html","title":"Mix.Tasks.Analyze","type":"task","doc":"This is used to run a LowEndInsight scan against a repository, by cloning it locally, then looking into it. Pass in the repo URL as a parameter to the task. #Usage mix analyze &quot;https://github.com/kitplummer/xmpp4rails&quot; | jq This will return a basic report (prettied by jq) as an Elixir Map. { &quot;data&quot;: { &quot;commit_currency_risk&quot;: &quot;critical&quot;, &quot;commit_currency_weeks&quot;: 563, &quot;contributor_count&quot;: 1, &quot;contributor_risk&quot;: &quot;critical&quot;, &quot;functional_contributor_names&quot;: [ &quot;Kit Plummer&quot; ], &quot;functional_contributors&quot;: 1, &quot;functional_contributors_risk&quot;: &quot;critical&quot;, &quot;large_recent_commit_risk&quot;: &quot;low&quot;, &quot;recent_commit_size_in_percent_of_codebase&quot;: 0.003683241252302026, &quot;repo&quot;: [ &quot;https://github.com/kitplummer/xmpp4rails&quot; ], &quot;risk&quot;: &quot;critical&quot; }, &quot;header&quot;: { &quot;duration&quot;: 1, &quot;end_time&quot;: &quot;2019-10-24 16:21:56.252768Z&quot;, &quot;source_client&quot;: &quot;mix task&quot;, &quot;start_time&quot;: &quot;2019-10-24 16:21:55.692010Z&quot;, &quot;uuid&quot;: &quot;659b37a2-f67a-11e9-ab5d-88e9fe666193&quot; } }"},{"ref":"Mix.Tasks.Analyze.html#run/1","title":"Mix.Tasks.Analyze.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"RiskLogic.html","title":"RiskLogic","type":"module","doc":"RiskLogic contains the functionality for determining risk based on numeric input values"},{"ref":"RiskLogic.html#commit_change_size_risk/1","title":"RiskLogic.commit_change_size_risk/1","type":"function","doc":"last_commit_size_risk/1: returns a text enumeration for the risk based on the size of the last commit"},{"ref":"RiskLogic.html#commit_currency_risk/1","title":"RiskLogic.commit_currency_risk/1","type":"function","doc":"commit_currency_risk/1: returns text enumeration for commit currency risk"},{"ref":"RiskLogic.html#contributor_risk/1","title":"RiskLogic.contributor_risk/1","type":"function","doc":"contributor_risk/1: returns text enumeration for count"},{"ref":"RiskLogic.html#functional_contributors_risk/1","title":"RiskLogic.functional_contributors_risk/1","type":"function","doc":"functional_contributors_risk/1: returns the enumerated risk based on input contributors list"},{"ref":"TimeHelper.html","title":"TimeHelper","type":"module","doc":"Collection of functions for handling time-based conversions."},{"ref":"TimeHelper.html#get_commit_delta/1","title":"TimeHelper.get_commit_delta/1","type":"function","doc":"get_commit_delta/1: returns the time between now and the last commit in seconds"},{"ref":"TimeHelper.html#sec_to_str/1","title":"TimeHelper.sec_to_str/1","type":"function","doc":"sec_to_str/1: returns a string breakdown of total seconds into weeks, days, hours, minutes and remaining seconds. Examples iex&gt; TimeHelper.sec_to_str(5211) &quot;1 hr, 26 min, 51 sec&quot;"},{"ref":"TimeHelper.html#sec_to_weeks/1","title":"TimeHelper.sec_to_weeks/1","type":"function","doc":"sec_to_str/1: returns a roll-up of weeks from a number of secs"},{"ref":"TimeHelper.html#sum_ts_diff/1","title":"TimeHelper.sum_ts_diff/1","type":"function","doc":"sum_ts_diff/1"},{"ref":"TimeHelper.html#sum_ts_diff/2","title":"TimeHelper.sum_ts_diff/2","type":"function","doc":"sum_ts_diff/2"},{"ref":"readme.html","title":"LowEndInsight","type":"extras","doc":"LowEndInsight LowEndInsight is a simple &quot;bus-factor&quot; risk analysis library for Open Source Software which is managed within a Git repository. Provide the git URL and the library will respond with a basic Elixir Map structure report. If you are at all concerned about risks associated with upstream dependency requirements LowEndInsight can provide valuable, and actionable information around the likelihood of critical issues being resolved, if ever reported. For example, a repo with a single contributor isn&#39;t necessarily bad, but it should be considered with some level of risk. Are you or your organization willing to assume ownership (fork) of the repository to resolve issues yourself? Or if there hasn&#39;t been a commit against the source repository, in some significant amount of time, can you assume that it is inactive, or just stable? Again, the intent of LowEndInsight isn&#39;t to say that any upstream Open Source dependency is bad, just that the risks should be smartly weighed, and a deeper understanding of the implications should be gained during the decision to use. LowEndInsight provides a simple mechanism for investigating and applying basic governance (based on your definition of the tolerance level) and responds with a useful report for integrating into your existing automation. Or you can easily use LowEndInsight as an ad-hoc reporting tool. ✗ mix analyze https://github.com/kitplummer/xmpp4rails | jq { &quot;data&quot;: { &quot;repos&quot;: [ { &quot;data&quot;: { &quot;commit_currency_risk&quot;: &quot;critical&quot;, &quot;commit_currency_weeks&quot;: 566, &quot;contributor_count&quot;: 1, &quot;contributor_risk&quot;: &quot;critical&quot;, &quot;functional_contributor_names&quot;: [ &quot;Kit Plummer&quot; ], &quot;functional_contributors&quot;: 1, &quot;functional_contributors_risk&quot;: &quot;critical&quot;, &quot;large_recent_commit_risk&quot;: &quot;low&quot;, &quot;recent_commit_size_in_percent_of_codebase&quot;: 0.003683241252302026, &quot;repo&quot;: &quot;https://github.com/kitplummer/xmpp4rails&quot;, &quot;risk&quot;: &quot;critical&quot; }, &quot;header&quot;: { &quot;duration&quot;: 0, &quot;end_time&quot;: &quot;2019-11-14 13:28:48.543895Z&quot;, &quot;source_client&quot;: &quot;mix task&quot;, &quot;start_time&quot;: &quot;2019-11-14 13:28:48.081742Z&quot;, &quot;uuid&quot;: &quot;b0b9921a-06e2-11ea-9a3c-784f434ce29a&quot; } } ] }, &quot;metadata&quot;: { &quot;repo_count&quot;: 1, &quot;risk_counts&quot;: { &quot;critical&quot;: 1 } } }"},{"ref":"readme.html#installation","title":"LowEndInsight - Installation","type":"extras","doc":"NOTE: the library is not currently deployed to Hex, while awaiting approvals to OSS. LowEndInsight available in Hex, the package can be installed by adding lowendinsight to your list of dependencies in mix.exs: def deps do [ {:lowendinsight, &quot;~&gt; 0.2.1&quot;} ] end NOTE: check hex.pm for the latest version."},{"ref":"readme.html#running","title":"LowEndInsight - Running","type":"extras","doc":"You either need to have Elixir and Erlang installed locally or possibly a container to run stuff in. REPL iex -S mix This will get you the iex prompt: Interactive Elixir (1.9.1) - press Ctrl+C to exit (type h() ENTER for help) iex(1)&gt; AnalyzerModule.analyze &quot;https://github.com/kitplummer/xmpp4rails&quot;, &quot;lib&quot; {:ok, %{ data: %{ commit_currency_risk: &quot;critical&quot;, commit_currency_weeks: 566, contributor_count: 1, contributor_risk: &quot;critical&quot;, functional_contributor_names: [&quot;Kit Plummer&quot;], functional_contributors: 1, functional_contributors_risk: &quot;critical&quot;, large_recent_commit_risk: &quot;low&quot;, recent_commit_size_in_percent_of_codebase: 0.003683241252302026, repo: &quot;https://github.com/kitplummer/xmpp4rails&quot;, risk: &quot;critical&quot; }, header: %{ duration: 1, end_time: &quot;2019-11-14 13:30:42.187082Z&quot;, source_client: &quot;lib&quot;, start_time: &quot;2019-11-14 13:30:41.076329Z&quot;, uuid: &quot;f4762608-06e2-11ea-ad1c-784f434ce29a&quot; } }} Possibly a tip (if you&#39;re running Docker): You can pass in this lib and configuration settings, into a base Elixir container. docker run -i --rm -v &quot;$PWD&quot;:/usr/src/myapp -w /usr/src/myapp -e LEI_CRITICAL_CURRENCY_LEVEL=60 elixir iex -S mix From iex you can access to the library functions. There is also an Elixir mix task that you can use to access the AnalyzeModule.analyze(url, client) function. mix analyze https://github.com/kitplummer/xmpp4rails, mix"},{"ref":"readme.html#docs","title":"LowEndInsight - Docs?","type":"extras","doc":"This is the library piece of the puzzle. There is a brewing API/service interface that will expose this library to HTTP(S) POSTs. Stay tuned, it&#39;ll be open sourced shortly following this library. The library is written in Elixir. mix docs will generate static docs available within the project in the docs/ subfolder. A Note about the metrics used Recent commit size: This is a measure of how large the most recent commit is in relatino to the size of the codebase. The idea being that a large recent commit is much more likely to be bug filled than a relatively small commit. Functional Contributors: A functional contributor is one that contributes above a certain percentage of commits equal to or greater than their &quot;fair&quot; share. Simply put, a contributor is counted as a functional contributor if the proportion of their commits to the total commits is greater than or equal to 1 / the total number of committers. If everyone committed the same amount, everyone would be a functional contributor. risk is a top-level key that contains the &quot;rolled up&quot; risk, the highest value pulled from any of the discrete analysis items. Configuration LowEndInsight allows for customization of the risk levels, to determine &quot;low&quot;, &quot;medium&quot;, &quot;high&quot; and &quot;critical&quot; acceptance. The library reads this configuration from config.exs here, or as providing in environment variables. ## Contributor in terms of discrete users ## NOTE: this currently doesn&#39;t discern same user with different email critical_contributor_level: String.to_integer(System.get_env(&quot;LEI_CRITICAL_CONTRIBUTOR_LEVEL&quot;) || &quot;2&quot;), high_contributor_level: System.get_env(&quot;LEI_HIGH_CONTRIBUTOR_LEVEL&quot;) || 3, medium_contributor_level: System.get_env(&quot;LEI_CRITICAL_CONTRIBUTOR_LEVEL&quot;) || 5, ## Commit currency in weeks - is the project active. This by itself ## may not indicate anything other than the repo is stable. The reason ## we&#39;re reporting it is relative to the likelihood vulnerabilities ## getting fix in a timely manner critical_currency_level: String.to_integer(System.get_env(&quot;LEI_CRITICAL_CURRENCY_LEVEL&quot;) || &quot;104&quot;), high_currency_level: String.to_integer(System.get_env(&quot;LEI_HIGH_CURRENCY_LEVEL&quot;) || &quot;52&quot;), medium_currency_level: String.to_integer(System.get_env(&quot;LEI_MEDIUM_CURRENCY_LEVEL&quot;) || &quot;26&quot;), ## Percentage of changes to repo in recent commit - is the codebase ## volatile in terms of quantity of source being changed critical_large_commit_level: String.to_float(System.get_env(&quot;LEI_CRITICAL_LARGE_COMMIT_LEVEL&quot;) || &quot;0.30&quot;), high_large_commit_level: String.to_float(System.get_env(&quot;LEI_HIGH_LARGE_COMMIT_LEVEL&quot;) || &quot;0.15&quot;), medium_large_commit_level: String.to_float(System.get_env(&quot;LEI_MEDIUM_LARGE_COMMIT_LEVEL&quot;) || &quot;0.05&quot;), ## Bell curve contributions - if there are 30 contributors ## but 90% of the contributions are from 2... critical_functional_contributors_level: String.to_integer(System.get_env(&quot;LEI_CRITICAL_FUNCTIONAL_CONTRIBUTORS_LEVEL&quot;) || &quot;2&quot;), high_functional_contributors_level: String.to_integer(System.get_env(&quot;LEI_HIGH_FUNCTIONAL_CONTRIBUTORS_LEVEL&quot;) || &quot;3&quot;), medium_functional_contributors_level: String.to_integer(System.get_env(&quot;LEI_MEDIUM_FUNCTIONAL_CONTRIBUTORS_LEVEL&quot;) || &quot;5&quot;) To override with an environment variable you just need to have it set: LEI_CRITICAL_CURRENCY_PAR_LEVEL=60 mix analyze https://github.com/kitplummer/xmpp4rails"},{"ref":"readme.html#contributing","title":"LowEndInsight - Contributing","type":"extras","doc":"Thanks for considering, we need your contributions to help this project come to fruition. Here are some important resources: Bugs? Issues is where to report them Style The repo includes auto-formatting, please run mix format to format to the standard style prescribed by the Elixir project: https://hexdocs.pm/mix/Mix.Tasks.Format.html https://github.com/christopheradams/elixir_style_guide Code docs for functions are expected. Examples are a bonus: https://hexdocs.pm/elixir/writing-documentation.html Testing Required. Please write ExUnit test for new code you create. Use mix test --cover to verify that you&#39;re maintaining coverage. Github Actions Just getting this built-out. But the bitbucket-pipeline config is still here too. Submitting changes Please send a Pull Request with a clear list of what you&#39;ve done and why. Please follow Elixir coding conventions (above in Style) and make sure all of your commits are atomic (one feature per commit). Always write a clear log message for your commits. One-line messages are fine for small changes, but bigger changes should look like this: $ git commit -m &quot;A brief summary of the commit &gt; &gt; A paragraph describing what changed and its impact.&quot;"},{"ref":"readme.html#license","title":"LowEndInsight - License","type":"extras","doc":"BSD 3-Clause. See https://opensource.org/licenses/BSD-3-Clause or LICENSE file for details."}]